//
// Mining module for TETDM 
// EditModule.java Version 0.36
// Copyright(C) 2011 2012 WATARU SUNAYAMA All RIGHTS RESERVED.
// This program is provided under the license.
// You Should read the README file.
//


package module.MiningModules.EditModule;

import source.*;
import source.TextData.*;

import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class EditModule extends MiningModule implements ActionListener
{
    JButton button[];
	JToggleButton tButton;
	
	String numberedText;

    String segment;
    String buttonNamesInJapanese[];
	
	public EditModule()
	{
		setModuleID(1);
		pairingVisualizationID = new int[]{1};
	}

	public void initializePanel()
	{
		buttonNamesInJapanese = fileReadArray();
		
		operationPanel.setBackground(Color.RED);

	    button = new JButton[4];

	    for(int i=0;i<4;i++)
		{
		    button[i] = new JButton();
		    button[i].setBackground(Color.RED);
		    button[i].addActionListener(this);
		    operationPanel.add(button[i]);
		}
		
		tButton = new JToggleButton();
		tButton.setBackground(Color.RED);
		tButton.addActionListener(this);
		operationPanel.add(tButton);		
		
	}	
	
	public void initializeData()
    {		
		String buttonNamesInEnglish[] = {"original text","save text","size --","size ++","numbered"};

		if(isMenuInJapanese())
		{
			for(int i=0;i<4;i++)
				button[i].setText(buttonNamesInJapanese[i]);
			tButton.setText(buttonNamesInJapanese[4]);
			segment = buttonNamesInJapanese[5];
		}
		else
		{
			for(int i=0;i<4;i++)
				button[i].setText(buttonNamesInEnglish[i]);
			tButton.setText(buttonNamesInEnglish[4]);			
			segment = "SEGMENT";
		}
    }
	
	void makeNumberedText()
	{
		StringWriter sw = new StringWriter();			//For words
		BufferedWriter bw = new BufferedWriter(sw);	
		
		try{
			for(int i=0;i<text.segmentNumber;i++)
			{
				bw.write("<"+segment+" : "+(i+1)+">");
				bw.newLine();
				for(int j=0;j<text.segment[i].sentenceNumber;j++)
				{
					bw.write((text.segment[i].sentence[j].positionOfSentence+1)+": ");
					for(int k=0;k<text.segment[i].sentence[j].wordNumber;k++)
						if(!text.segment[i].sentence[j].word[k].equals("\n"))
							bw.write(text.segment[i].sentence[j].word[k]);
					bw.newLine();
				}
			}
			bw.flush();
		}
		catch(Exception e){
			System.out.println("writing ERROR in EditModule");
		}		

		numberedText = sw.toString();		
	}
	
	public void miningOperations(int optionNumber)
	{
		switch(optionNumber)
		{
			case 0:
				setDataString(0,text.originalText);
				break;
				
			case 1:
				makeNumberedText();
				setDataString(1,numberedText);
				displayOperations(0);
				break;
				
			case 2:
				text.fileLoad();
				break;
		}
	}
	
	//Action listener
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == button[0])
			miningOperations(2);

		if(e.getSource() == button[1])
			displayOperations(1);

		if(e.getSource() == button[2])
			displayOperations(9);

		if(e.getSource() == button[3])
			displayOperations(10);

		if(e.getSource() == tButton)
		{
			if(tButton.isSelected())
				miningOperations(1);
			else
				displayOperations(100);
		}
	}
}
