//
// Visuzalization module for TETDM 
// KeywordSelect.java Version 0.30
// Copyright(C) 2008 WATARU SUNAYAMA ALL RIGHTS RESERVED.
//
// This program is provided under the license.
// You should read the README file.
//

package module.VisualizationModules.KeywordSelect;

import source.*;
import source.TextData.*;
import source.Utility.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class KeywordSelect extends VisualizationModule implements ItemListener
{
	int checkWords[];
	int checkedNumber;
	
	boolean setting;	// make checks for all boxes
	
	CheckBoxPanel checkBoxPanel[];
	int boxNumber;
	
	class CheckBoxPanel extends JPanel
	{
		JLabel label;
		JPanel select;
		JScrollPane check;	
		JCheckBox ch[];
		
		double values[];
		
		int sortedIndex[];
		int sortedIndexBak[];
		
		CheckBoxPanel()
		{
			setLayout(new BorderLayout());
			
			label = new JLabel();
			add(label, BorderLayout.NORTH);
			
			select = new JPanel();
			check = new JScrollPane(select);
			
			select.setBackground(Color.white);
			select.setLayout(new BoxLayout(select, BoxLayout.Y_AXIS));
			
			add(check);
			
			values = new double[text.keywordNumber];
		}
		
		void setValue(double value[])
		{
			for(int i=0;i<text.keywordNumber;i++)
				values[i] = value[i];			
		}
		
		void setLabel(String labelText)
		{
			label.setText(labelText);
		}
		
		void initialize(ItemListener item)
		{			
			ch = new JCheckBox[text.keywordNumber];
			sortedIndex = new int[text.keywordNumber];
			sortedIndexBak = new int[text.keywordNumber];
			
			createCheckBox(item);
		}

		void createCheckBox(ItemListener item)		
		{
			Qsort.initializeIndex(sortedIndex, text.keywordNumber);
			Qsort.quicksort(values, sortedIndex, text.keywordNumber);
			
			for(int i=0; i<text.keywordNumber;i++)
			{
				ch[i] = new JCheckBox(text.keyword[sortedIndex[i]].word);
				ch[i].addItemListener(item);
				ch[i].setBackground(Color.white);
				
				if(values[i] > 0)
					select.add(ch[i]);
				
				sortedIndexBak[sortedIndex[i]] = i;
			}
		}

		void findCheck()
		{
			checkedNumber = 0;
			for(int i=0;i<text.keywordNumber;i++)
				if(ch[i].isSelected() == true)
					checkWords[checkedNumber++] = sortedIndex[i];
		}
		
		void setCheck()
		{
			setting = true;
			for(int i=0;i<text.keywordNumber;i++)
				ch[i].setSelected(false);				
			
			for(int i=0;i<checkedNumber;i++)
				ch[sortedIndexBak[checkWords[i]]].setSelected(true);
			setting = false;
		}
	}

	public KeywordSelect()
	{
		setModuleID(9);	
	}
	
	public void initializePanel()
	{
		boxNumber = 1;
	}
	
	public void initializeData(){}
	
	public void initBox1()
	{
		removeAll();
		
		setLayout(new GridLayout(1,boxNumber));
		checkBoxPanel = new CheckBoxPanel[boxNumber];
		
		for(int i=0;i<boxNumber;i++)
		{
			checkBoxPanel[i] = new CheckBoxPanel();
			add(checkBoxPanel[i]);
		}		
		
		checkWords = new int[text.keywordNumber];
		
		revalidate();
	}
	
	public void initBox2()
	{
		for(int i=0;i<boxNumber;i++)
			checkBoxPanel[i].initialize((ItemListener)this);
		
		checkedNumber = 0;		
		for(int i=0;i<text.keywordNumber;i++)
			if(text.focus.focusKeywords[i])
				checkWords[checkedNumber++] = i;
		
		for(int j=0;j<boxNumber;j++)
			checkBoxPanel[j].setCheck();		
	}
	
	public void displayOperations(int optionNumber)
	{
		switch(optionNumber)
		{
			case 0:
				initBox2();
				break;
		}		
	}
	
	public void setData(int dataID, int data)
	{
		switch(dataID)
		{
			case 77:
				boxNumber = data;
				initBox1();
				break;
		}
	}
	
	public void setData(int dataID, double data[])
	{
		switch(dataID)
		{
			default:
				if(dataID < 10 || dataID > 20)
					break;
				checkBoxPanel[dataID-10].setValue(data);
				break;
		}
	}
	
	public void setData(int dataID, String data)
	{
		switch(dataID)
		{
			default:
				if(dataID < 10 || dataID > 20)
					break;
				checkBoxPanel[dataID-10].setLabel(data);
				break;
		}
	}	
	
	public void itemStateChanged(ItemEvent e)
	{
		int boxID;
		
		if(setting == false)
		{
			for(int i=0;i<text.keywordNumber;i++)
			{
				for(boxID = 0; boxID < boxNumber; boxID++)
					if(e.getItemSelectable() == checkBoxPanel[boxID].ch[i])
					{
						checkBoxPanel[boxID].findCheck();
						break;
					}
				
				if(boxID < boxNumber)
					for(int j=0;j<boxNumber;j++)
						if(j != boxID)
							checkBoxPanel[j].setCheck();
			}
			
			for(int i=0;i<text.keywordNumber;i++)
				text.focus.focusKeywords[i] = false;
			for(int i=0;i<checkedNumber;i++)
				text.focus.focusKeywords[checkWords[i]] = true;
			executeOthersByClick();
		}
	}
}
