//
// Visuzalization module for TETDM 
// SegmentSelect.java Version 0.30
// Copyright(C) 2008 WATARU SUNAYAMA ALL RIGHTS RESERVED.
//
// This program is provided under the license.
// You should read the README file.
//

package module.VisualizationModules.SegmentSelect;

import source.*;
import source.TextData.*;
import source.Utility.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class SegmentSelect extends VisualizationModule implements ItemListener
{
	int checkWords[];
	int checkedNumber;
	
	boolean setting;	
	
	CheckBoxPanel checkBoxPanel;

	
	class CheckBoxPanel extends JPanel
	{
		JLabel label;
		JPanel select;
		JScrollPane check;	
		JCheckBox ch[];

		CheckBoxPanel()
		{
			setLayout(new BorderLayout());
			
			label = new JLabel();
			add(label, BorderLayout.NORTH);
			
			select = new JPanel();
			check = new JScrollPane(select);
			
			select.setBackground(Color.white);
			select.setLayout(new BoxLayout(select, BoxLayout.Y_AXIS));
			
			add(check);
		}
		
		void initialize(ItemListener item)
		{			
			ch = new JCheckBox[text.segmentNumber];
			createCheckBox(item);
		}

		void createCheckBox(ItemListener item)		
		{
			for(int i=0; i<text.segmentNumber;i++)
			{
				ch[i] = new JCheckBox("SEG"+(text.segment[i].segmentID+1)+" : "
									  +text.segment[i].segmentText.substring(0,Math.min(100,text.segment[i].segmentText.length())));
				ch[i].addItemListener(item);
				ch[i].setBackground(Color.white);
				
				select.add(ch[i]);				
			}
		}

		void findCheck()
		{
			checkedNumber = 0;
			for(int i=0;i<text.segmentNumber;i++)
				if(ch[i].isSelected() == true)
					checkWords[checkedNumber++] = i;
		}
		
		void setCheck()
		{
			setting = true;				
			for(int i=0;i<text.segmentNumber;i++)
				ch[i].setSelected(false);				
			
			for(int i=0;i<checkedNumber;i++)
				ch[checkWords[i]].setSelected(true);
			setting = false;			
		}
	}

	public SegmentSelect()
	{
		setModuleID(1100);	
	}
	
	public void initializePanel(){}
	
	public void initializeData()
	{
		initBox1();
	}
	
	public void initBox1()
	{
		removeAll();
		
		setLayout(new GridLayout(1,1));
		checkBoxPanel = new CheckBoxPanel();
		
		add(checkBoxPanel);
		
		checkWords = new int[text.segmentNumber];
		
		revalidate();			
	}
	
	public void initBox2()
	{
		checkBoxPanel.initialize((ItemListener)this);
		
		checkedNumber = 0;		
		for(int i=0;i<text.segmentNumber;i++)
			if(text.focus.focusSegments[i])
				checkWords[checkedNumber++] = i;
		
		checkBoxPanel.setCheck();		
	}
	
	public void displayOperations(int optionNumber)
	{
		switch(optionNumber)
		{
			case 0:
				initBox2();
				break;
		}		
	}
	
	public void itemStateChanged(ItemEvent e)
	{
		if(setting == false)
		{
			for(int i=0;i<text.segmentNumber;i++)
				if(e.getItemSelectable() == checkBoxPanel.ch[i])
				{
					checkBoxPanel.findCheck();
					break;
				}
			
			for(int i=0;i<text.segmentNumber;i++)
				text.focus.focusSegments[i] = false;
			for(int i=0;i<checkedNumber;i++)
				text.focus.focusSegments[checkWords[i]] = true;
		}
		repaintOthersByClick();
	}
}
