//
// Core Program for TETDM 
// SetModulePanel.java Version 0.44
// Copyright(C) 2011-2013 TETDM CORE MEMBER ALL RIGHTS RESERVED.
// This program is provided under the license.
//

package source;

//import source.*;
import source.TextData.*;
import source.Utility.*;

import java.io.File;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.GroupLayout.Alignment;


public class SetModulePanel extends JPanel implements ActionListener, ItemListener
{
	JPanel allTopPanel;
	JPanel topPanel1;
	JPanel topPanel2;
	JPanel leftTopPanel;
	JPanel rightTopPanel;
	
	JPanel upperPanel;

	JPanel rightPanel;
    
	JPanel buttonPanel;
	JPanel buttonPanel1;
	JPanel buttonPanel2;
	
	
	//Top
	JLabel message;
	JLabel keywordSettingLabel = new JLabel();
	JLabel moduleSelectLabel = new JLabel();
	
	//Text pane	for left
	JTextPane textBox[];
	JScrollPane scroll[];
	String displayText[];	//display text
	
	JPanel setPanel;
	JLabel setFieldLabel;
	JTextField setField;
	JCheckBox setBox[];
	ButtonGroup checkGroup;
	
	//Module Selection
	JPanel instructionPanel;
	JLabel instruction1;
	JLabel instruction2;
	JLabel instruction3;
	
	JPanel boxPanel;
	JPanel miningSelect, visualizationSelect;
    
	GroupLayout layout1, layout2;
	GroupLayout.SequentialGroup vGroup1, vGroup2;
	GroupLayout.SequentialGroup hGroup1, hGroup2;
	
	GroupLayout.ParallelGroup checkBoxGroup1, checkBoxGroup2, checkBoxGroup3;
	GroupLayout.ParallelGroup radioButtonGroup;
    
	GroupLayout.ParallelGroup resetButtonGroup;
	JButton resetButton[];
    
	JScrollPane miningScroll, visualizationScroll;
	JCheckBox miningBox[], visualizationBox[];
	JRadioButton miningBox2[];
	ButtonGroup group = new ButtonGroup();
	JCheckBox visualizationBox2[];
	int selectedModuleNumber = 0;
	
	//Button
	JButton bt0 = new JButton();
	JButton bt10 = new JButton();
	
	JButton bt20 = new JButton();
	JButton bt30 = new JButton();
	
	JButton bt40 = new JButton();
	
	
	int fontsize = 16;
	
	String menuInJapanese[];
	
	SettingData settingData;
	ModuleData moduleData;
	
	boolean autoSet;
	
	Control control;
	
	
	SetModulePanel(SettingData settingD, Control control)
	{
		setLayout(new BorderLayout());
		
		settingData = settingD;
		this.control = control;
		moduleData = settingD.moduleData;
		
		menuInJapanese = FILEIO.TextFileAllReadCodeArray(new File(settingData.absolutePath + "source" + File.separator + "Japanese.txt"));
		
		//ALL
		allTopPanel = new JPanel(new GridLayout(2,1));
		topPanel1 = new JPanel();
		topPanel2 = new JPanel();
		
		//TOP
		topPanel1.setBackground(Color.green);
		topPanel2.setBackground(Color.orange);
		
		add(allTopPanel, BorderLayout.NORTH);
		allTopPanel.add(topPanel1);
		allTopPanel.add(topPanel2);


		message = new JLabel();
		message.setFont(new Font("Dialog", Font.BOLD, fontsize+4));
		message.setForeground(Color.blue);
        
		keywordSettingLabel = new JLabel();
		keywordSettingLabel.setFont(new Font("Dialog", Font.BOLD, fontsize));
		moduleSelectLabel = new JLabel();
		moduleSelectLabel.setFont(new Font("Dialog", Font.BOLD, fontsize));
		
		setTitleNames();
        
		topPanel1.add(message);
		topPanel2.add(moduleSelectLabel);
		
        
		//MIDDLE
		//MIDDLE Right
        
		rightPanel = new JPanel(new BorderLayout());
		add(rightPanel);


		instruction1 = new JLabel();
		instruction2 = new JLabel();
		instruction3 = new JLabel();
		instruction1.setFont(new Font("Dialog", Font.BOLD, fontsize-4));
		instruction2.setFont(new Font("Dialog", Font.BOLD, fontsize-4));
		instruction3.setFont(new Font("Dialog", Font.BOLD, fontsize-4));
		
		setInstructions();
		
		instructionPanel = new JPanel(new GridLayout(3,1));
		instructionPanel.setBackground(new Color(0xE0,0xFF,0xFF));
		rightPanel.add(instructionPanel, BorderLayout.NORTH);
		instructionPanel.add(instruction1);
		instructionPanel.add(instruction2);
		instructionPanel.add(instruction3);
        
		createModuleSelectPanel();
		
		initializeCheckBox();
		initializeCheckBox2();
        
		//BOTTOM
        setNames();
        
		buttonPanel = new JPanel(new GridLayout(2,1));
		add(buttonPanel, BorderLayout.SOUTH);
		
		buttonPanel1 = new JPanel(new GridLayout());
		buttonPanel2 = new JPanel(new GridLayout());
        
		buttonPanel.add(buttonPanel1);
		buttonPanel.add(buttonPanel2);
        
		buttonPanel1.setBackground(Color.ORANGE);
		buttonPanel2.setBackground(Color.GREEN);
        
        
//		bt30.addActionListener(this);
//		bt30.setBackground(Color.ORANGE);
//		buttonPanel1.add(bt30);
        
		bt20.addActionListener(this);
		bt20.setBackground(Color.ORANGE);
		buttonPanel1.add(bt20);
		
        
		
		bt0.addActionListener(this);
		bt0.setBackground(Color.GREEN);
		buttonPanel2.add(bt0);
		
		bt10.addActionListener(this);
		bt10.setBackground(Color.GREEN);
		buttonPanel2.add(bt10);
        
		bt40.addActionListener(this);
		bt40.setBackground(Color.GREEN);
		buttonPanel2.add(bt40);
	}
	
	public void setTitleNames()
	{
		if(settingData.inJapanese)
		{
			message.setText(menuInJapanese[0]);
			moduleSelectLabel.setText(menuInJapanese[13]);
			keywordSettingLabel.setText(menuInJapanese[18]);
		}
		else
		{
			message.setText("Tool SETTINGS (Please push the SETTINGS button after you customized)");
			moduleSelectLabel.setText("Mining Tools -- Visualization Tools");

		}
	}
	
	public void setInstructions()
	{
		if(settingData.inJapanese)
		{
			instruction1.setText(menuInJapanese[19]);
			instruction2.setText(menuInJapanese[20]);
			instruction3.setText(menuInJapanese[21]);
		}
		else
		{
			instruction1.setText("  Mining Tool: Please check square boxes which you use");
			instruction2.setText("  Visualization Tool: Please check square boxes which you use");
			instruction3.setText("    after you checked a round button placed at right side of mining tools");
		}
	}
	
	public void setNames()
	{
		if(settingData.inJapanese)
		{            
			bt0.setText(menuInJapanese[14]);
			bt10.setText(menuInJapanese[15]);
			bt20.setText(menuInJapanese[16]);
			bt30.setText(menuInJapanese[17]);
			bt40.setText(menuInJapanese[23]);
		}
		else
		{            
			bt0.setText("Load Original Settings");
			bt10.setText("Save Settings");
			bt20.setText("Reconstruct Panels");
			bt30.setText("Reset TextData");
			bt40.setText("Quit Settings");
		}
	}
	

	
	public void createModuleSelectPanel()
	{
        
        
		
		boxPanel = new JPanel();
		boxPanel.setLayout(new GridLayout(1,2));
		//		boxPanel.setLayout(new BoxLayout(boxPanel, BoxLayout.X_AXIS));
		
        //		rightPanel.add(headerPanel, BorderLayout.NORTH);
		rightPanel.add(boxPanel);
        
		miningSelect = new JPanel();
		miningSelect.setBackground(Color.pink);
		layout1 = new GroupLayout(miningSelect);
		miningSelect.setLayout(layout1);
		vGroup1 = layout1.createSequentialGroup();
		hGroup1 = layout1.createSequentialGroup();
        checkBoxGroup1 = layout1.createParallelGroup();
        radioButtonGroup = layout1.createParallelGroup();
		resetButtonGroup = layout1.createParallelGroup();
        
		visualizationSelect = new JPanel();
		visualizationSelect.setBackground(Color.cyan);
		layout2 = new GroupLayout(visualizationSelect);
		visualizationSelect.setLayout(layout2);
		vGroup2 = layout2.createSequentialGroup();
		hGroup2 = layout2.createSequentialGroup();
        checkBoxGroup2 = layout2.createParallelGroup();
        checkBoxGroup3 = layout2.createParallelGroup();
        
		miningScroll = new JScrollPane(miningSelect);
		visualizationScroll = new JScrollPane(visualizationSelect);
		boxPanel.add(miningScroll);
		boxPanel.add(visualizationScroll);
        
		miningBox = new JCheckBox[moduleData.module_names.length];
		miningBox2 = new JRadioButton[moduleData.module_names.length];
        
		resetButton = new JButton[moduleData.module_names.length];
		
		visualizationBox2 = new JCheckBox[moduleData.visu_module_names.length];
		visualizationBox = new JCheckBox[moduleData.visu_module_names.length];
        
		createCheckBox1();
		
		layout1.setVerticalGroup(vGroup1);
		layout1.setHorizontalGroup(hGroup1);
		layout2.setVerticalGroup(vGroup2);
		layout2.setHorizontalGroup(hGroup2);
		
		createCheckBox2();
        
		for(int i=0;i<moduleData.module_names.length;i++)
			group.add(miningBox2[i]);
		
		for(int i=0;i<moduleData.visu_module_names.length;i++)
			visualizationBox[i].setEnabled(false);
	}
	
	public void setCheckBoxNames1()
	{
		for(int i=0; i<moduleData.module_names.length;i++)
			if(settingData.inJapanese)
			{
				miningBox[i].setText(moduleData.miningModuleNamesInJapanese[i]+"("+moduleData.moduleIDs[i]+")");
				resetButton[i].setText(menuInJapanese[22]);
			}
			else
			{
				miningBox[i].setText(moduleData.module_names[i]+"("+moduleData.moduleIDs[i]+")");
				resetButton[i].setText("Reset");
			}
	}
	
	public void createCheckBox1()
	{
		for(int i=0; i<moduleData.module_names.length;i++)
		{
			miningBox[i] = new JCheckBox();
			miningBox[i].setFont(new Font("Dialog", Font.BOLD, fontsize));
			miningBox[i].setBackground(Color.pink);
			miningBox[i].addItemListener(this);
			
			miningBox2[i] = new JRadioButton();
			miningBox2[i].setFont(new Font("Dialog", Font.BOLD, fontsize));
			miningBox2[i].setBackground(Color.pink);
			miningBox2[i].addItemListener(this);
			
			resetButton[i] = new JButton();
			resetButton[i].setBackground(Color.pink);
			resetButton[i].addActionListener(this);
            
			GroupLayout.ParallelGroup group = layout1.createParallelGroup(Alignment.BASELINE);
			group.addComponent(miningBox[i]);
			group.addComponent(miningBox2[i]);
			group.addComponent(resetButton[i]);
			vGroup1.addGroup(group);
			
			checkBoxGroup1.addComponent(miningBox[i]);
			radioButtonGroup.addComponent(miningBox2[i]);
			resetButtonGroup.addComponent(resetButton[i]);
		}
        
		
		hGroup1.addGroup(checkBoxGroup1);
		hGroup1.addGroup(radioButtonGroup);
		hGroup1.addGroup(resetButtonGroup);
        
		setCheckBoxNames1();
	}
	
	public void setCheckBoxNames2()
	{
		for(int i=0; i<moduleData.visu_module_names.length;i++)
			if(settingData.inJapanese)
				visualizationBox2[i].setText(moduleData.visualizationModuleNamesInJapanese[i]+"("+moduleData.visuModuleIDs[i]+")");
			else
				visualizationBox2[i].setText(moduleData.visu_module_names[i]+"("+moduleData.visuModuleIDs[i]+")");
	}
	
	public void createCheckBox2()
	{
		for(int i=0; i<moduleData.visu_module_names.length;i++)
		{
			//			visualizationBox2[i] = new JCheckBox(moduleData.visu_module_names[i]);
			visualizationBox2[i] = new JCheckBox();
			visualizationBox2[i].setFont(new Font("Dialog", Font.BOLD, fontsize));
			visualizationBox2[i].setBackground(Color.cyan);
			visualizationBox2[i].addItemListener(this);
			
			visualizationBox[i] = new JCheckBox();
			visualizationBox[i].setBackground(Color.cyan);
			visualizationBox[i].setFont(new Font("Dialog", Font.BOLD, fontsize));
			
			GroupLayout.ParallelGroup group = layout2.createParallelGroup(Alignment.BASELINE);
			group.addComponent(visualizationBox2[i]);
			group.addComponent(visualizationBox[i]);
			vGroup2.addGroup(group);
			
			checkBoxGroup2.addComponent(visualizationBox2[i]);
			checkBoxGroup3.addComponent(visualizationBox[i]);
		}
		
		hGroup2.addGroup(checkBoxGroup2);
		hGroup2.addGroup(checkBoxGroup3);
		
		setCheckBoxNames2();
	}
    
	public void initializeCheckBox()
	{
		for(int i=0;i<moduleData.module_names.length;i++)
			miningBox[i].setSelected(moduleData.miningModuleSelection[i]);
	}
	
	public void setCheckBox2AndResetButton(int n)
	{
		miningBox2[n].setSelected(true);
		resetButton[n].setEnabled(true);
		
		for(int i=0;i<moduleData.module_names.length;i++)
			if(i != n)
			{
				miningBox2[i].setSelected(false);
				resetButton[i].setEnabled(false);
			}
	}
	
	public void initializeCheckBox2()
	{
		for(int i=0;i<moduleData.module_names.length;i++)
			if(miningBox[i].isSelected())
			{
				setCheckBox2AndResetButton(i);
				break;
			}
		
		setVisualizationCheckBox();	//for 2
	}
	
	//for 2
	public void setVisualizationCheckBox()
	{
		autoSet = true;
		for(int j=0;j<moduleData.visu_module_names.length;j++)
			visualizationBox2[j].setSelected(false);
        
		for(int j=0;j<moduleData.visu_module_names.length;j++)
			for(int k=0;k<moduleData.mining[selectedModuleNumber].pairingVisualizationID.length;k++)
				if(moduleData.visuModuleIDs[j] == moduleData.mining[selectedModuleNumber].pairingVisualizationID[k])
					visualizationBox2[j].setSelected(true);
		autoSet = false;
	}
	
	void resetPairingVisualization()
	{
		moduleData.mining[selectedModuleNumber].pairingVisualizationID = new int[moduleData.mining[selectedModuleNumber].pairingVisuID.length];

		for(int i=0;i<moduleData.mining[selectedModuleNumber].pairingVisuID.length;i++)
			moduleData.mining[selectedModuleNumber].pairingVisualizationID[i] = moduleData.mining[selectedModuleNumber].pairingVisuID[i];

		moduleData.setModuleIndex(selectedModuleNumber, moduleData.mining[selectedModuleNumber].pairingVisuID);

		for(int i=0;i<moduleData.visu_module_names.length;i++)		
			moduleData.createPairingMiningID(i);		
	}
	
	void resetAllPairingVisualization()
	{
		for(int k=0;k<moduleData.module_names.length;k++)
		{
			moduleData.mining[k].pairingVisualizationID = new int[moduleData.mining[k].pairingVisuID.length];
			for(int i=0;i<moduleData.mining[k].pairingVisuID.length;i++)
				moduleData.mining[k].pairingVisualizationID[i] = moduleData.mining[k].pairingVisuID[i];
			
			moduleData.setModuleIndex(k, moduleData.mining[k].pairingVisuID);

			for(int i=0;i<moduleData.visu_module_names.length;i++)		
				moduleData.createPairingMiningID(i);			
		}
	}

	
	public void resetVisualizationSelection()
	{
		moduleData.initializeVisualiationModuleSelection();
		
		for(int j=0;j<moduleData.visu_module_names.length;j++)
			visualizationBox[j].setSelected(moduleData.visualizationModuleSelection[j]);
	}
    
	//Action listener
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == setField)
		{
			settingData.chasenPath = setField.getText();
			return;
		}
		
		for(int i=0;i<moduleData.module_names.length;i++)
			if(e.getSource() == resetButton[i])
			{
				resetPairingVisualization();
				setVisualizationCheckBox();
				resetVisualizationSelection();
				
			}
		
		// Reconstruct Panels
		if(e.getSource() == bt20)
		{
			control.moduleData.initializeModuleSubset();
			control.panelsReConstruction();
			control.setButtonLabel();					// for English Menu
		}
		
		// Reset TextData
		if(e.getSource() == bt30)
		{			
			control.textDataLoadingWithoutCopy();/////
			control.resetSelectpanelData(control.text);
		}
		
		if(e.getSource() == bt0)//Load Original Settings
		{
			resetAllPairingVisualization();
            
			settingData.readOriginalSettingFile();
			initializeCheckBox();
			initializeCheckBox2();
			resetVisualizationSelection();
			



			
            
			
			if(settingData.inJapanese)
				message.setText(menuInJapanese[1]);
			else
				message.setText("SETTINGS ARE LOADED (Please push the Settings button after you customized)");
            
		}
		
		if(e.getSource() == bt10)//Save Settings
		{
			settingData.saveSettingFile();
			if(settingData.inJapanese)
				message.setText(menuInJapanese[2]);
			else
				message.setText("SETTINGS ARE SAVED (Please push the Settings button after you customized)");
		}
        
		// Quit Settings
		if(e.getSource() == bt40)
		{
			control.btx.setSelected(false);
			control.popForSetModule.dispose();
		}
	}
	

	
	
	
	public void itemStateChanged(ItemEvent e)
	{
		for(int i=0;i<miningBox2.length;i++)//////////
			if(e.getSource() == miningBox2[i])
			{
				resetButton[selectedModuleNumber].setEnabled(false);
				resetButton[i].setEnabled(true);
				selectedModuleNumber = i;
				setVisualizationCheckBox();
				return;
			}
        
		if(autoSet)
			return;
        
		for(int k=0;k<miningBox.length;k++)
			if(e.getSource() == miningBox[k])
			{
				moduleData.miningModuleSelection[k] = miningBox[k].isSelected();
				
				int count=0, firstm=-1;
				for(int i=0;i<miningBox.length;i++)
					if(miningBox[i].isSelected())
					{
						if(firstm == -1)
							firstm = i;
						count++;
					}
				
				if(miningBox[k].isSelected())
					firstm = k;
				
				if(count == 0)
				{
					miningBox[k].setSelected(true);
					setCheckBox2AndResetButton(k);
				}
				else
				{
					setCheckBox2AndResetButton(firstm);
					resetVisualizationSelection();
				}
                
				return;
			}
		
		for(int i=0;i<visualizationBox2.length;i++)
			if(e.getSource() == visualizationBox2[i])
			{
				for(int k=0;k<miningBox2.length;k++)
					if(miningBox2[k].isSelected())
					{
						selectedModuleNumber = k;
						break;
					}
				
				int count=0;
				for(int k=0;k<visualizationBox2.length;k++)
					if(visualizationBox2[k].isSelected())
						count++;
				
				if(count == 0)
				{
					for(int k=0;k<visualizationBox2.length;k++)
						if(moduleData.visuModuleIDs[k] == moduleData.mining[selectedModuleNumber].pairingVisualizationID[0])
							visualizationBox2[k].setSelected(true);
					count = 1;
				}
				
				moduleData.mining[selectedModuleNumber].pairingVisualizationID = new int[count];
				moduleData.mining[selectedModuleNumber].pairingVisualizationIndex = new int[count];				
                
				count = 0;
				for(int k=0;k<visualizationBox2.length;k++)
					if(visualizationBox2[k].isSelected())
					{
						moduleData.mining[selectedModuleNumber].pairingVisualizationID[count] = moduleData.visuModuleIDs[k];
						moduleData.mining[selectedModuleNumber].pairingVisualizationIndex[count] = moduleData.findVisualizationModule(moduleData.visuModuleIDs[k]);
						count++;
					}
                
				resetVisualizationSelection();
                
				return;				
			}
	}
}



/*
 int newPanelNumber = 0;
 
 public class SetToolPanel(Control control)
 {
    setLayout(new BorderLayout());
 
    newPanelNumber = 2;
 
    control.miningIDs = new int[newPanelNumber];
    control.visualizationIDs = new int[newPanelNumber];
 
    control.miningIDs[0] = 12;
    control.visualizationIDs[0] = 4;
    control.miningIDs[1] = 19;
    control.visualizationIDs[1] = 3;
 
    control.panelSet();
 
    for(int i=0;i<control.moduleData.moduleIDs.length;i++)
        System.out.println(control.moduleData.moduleIDs[i]+":"+control.moduleData.module_names[i]);
 
    for(int i=0;i<control.moduleData.visuModuleIDs.length;i++)
        System.out.println(control.moduleData.visuModuleIDs[i]+":"+control.moduleData.visu_module_names[i]);
 }
*/
