//
// Core Program for TETDM 
// SettingPanel.java Version 0.44
// Copyright(C) 2011-2013 TETDM CORE MEMBER ALL RIGHTS RESERVED.
// This program is provided under the license.
//

package source;

//import source.*;
import source.TextData.*;
import source.Utility.*;

import java.io.File;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.GroupLayout.Alignment;


public class SettingPanel extends JPanel implements ActionListener, ItemListener
{
	JPanel allTopPanel;
	JPanel leftPanel;

	JPanel buttonPanel;
	JPanel buttonPanel1;
	JPanel buttonPanel2;	
	
	
	//Top
	JLabel message;


	
	//Text pane	for left	
	JTextPane textBox[];
	JScrollPane scroll[];
	String displayText[];	//display text
	
	JPanel setPanel;
	JLabel setFieldLabel;
	JTextField setField;
	JCheckBox setBox[];
	ButtonGroup checkGroup;
	

	
	//Buttom
	JButton bt0 = new JButton();	
	JButton bt10 = new JButton();
	JButton bt20 = new JButton();
	JButton bt30 = new JButton();	
	JButton bt40 = new JButton();
	
	
	int fontsize = 16;
	
	String menuInJapanese[];
	
	SettingData settingData;
	
	boolean autoSet;
	
	Control control;
	
	
	SettingPanel(SettingData settingD, Control control)
	{
		setLayout(new BorderLayout());
		
		settingData = settingD;
		this.control = control;
		
		menuInJapanese = FILEIO.TextFileAllReadCodeArray(new File(settingData.absolutePath + "source" + File.separator + "Japanese.txt"));		
		
		//ALL
		allTopPanel = new JPanel();
        allTopPanel.setBackground(Color.green);
		add(allTopPanel, BorderLayout.NORTH);

		message = new JLabel();
		message.setFont(new Font("Dialog", Font.BOLD, fontsize+4));
		message.setForeground(Color.blue);
		
		setTitleNames();
		allTopPanel.add(message);

		//MIDDLE
		leftPanel = new JPanel();		
		leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.Y_AXIS));
        add(leftPanel);

		//MIDDLE Left
		textBox = new JTextPane[5];
		scroll = new JScrollPane[6];
		
		for(int i=0;i<5;i++)
		{
			textBox[i] = new JTextPane();
			scroll[i] = new JScrollPane(textBox[i]);
			leftPanel.add(scroll[i]);
		}
		displayText = new String[5];
		
		for(int i=0;i<5;i++)
			displayText[i] = "Nothing";

		setPanel = new JPanel();
		setPanel.setBackground(Color.white);
		setPanel.setLayout(new BoxLayout(setPanel, BoxLayout.Y_AXIS));		
		createSetPanel();
		scroll[5] = new JScrollPane(setPanel);
		leftPanel.add(scroll[5]);

		initializeSetBox();		

		//BOTTOM
		buttonPanel = new JPanel(new GridLayout(2,1));
		add(buttonPanel, BorderLayout.SOUTH);
		
		buttonPanel1 = new JPanel(new GridLayout());
		buttonPanel2 = new JPanel(new GridLayout());
			
		buttonPanel.add(buttonPanel1);		
		buttonPanel.add(buttonPanel2);		

		buttonPanel1.setBackground(Color.ORANGE);		
		buttonPanel2.setBackground(Color.GREEN);		


		bt30.addActionListener(this);
		bt30.setBackground(Color.ORANGE);		
		buttonPanel1.add(bt30);

//		bt20.addActionListener(this);
//		bt20.setBackground(Color.ORANGE);
//		buttonPanel1.add(bt20);
		

		
		bt0.addActionListener(this);
		bt0.setBackground(Color.GREEN);		
		buttonPanel2.add(bt0);		
		
		bt10.addActionListener(this);
		bt10.setBackground(Color.GREEN);		
		buttonPanel2.add(bt10);

		bt40.addActionListener(this);
		bt40.setBackground(Color.GREEN);		
		buttonPanel2.add(bt40);
	}
	
	public void createSetPanel()
	{
		setBox = new JCheckBox[9];
		checkGroup = new ButtonGroup();
		
		setFieldLabel = new JLabel();
		setFieldLabel.setFont(new Font("Dialog", Font.BOLD, fontsize));
		setPanel.add(setFieldLabel);
		setField = new JTextField(settingData.chasenPath, 1);
		setField.setFont(new Font("Dialog", Font.BOLD, fontsize));
//		setField.setPreferredSize(new Dimension(500, 20));
		setField.addActionListener(this);
		setPanel.add(setField);
		setField.setEnabled(!settingData.isWindows);
		
		for(int i=0;i<9;i++)
		{
			setBox[i] = new JCheckBox();
			setBox[i].addItemListener(this);
			setBox[i].setBackground(Color.white);
			setPanel.add(setBox[i]);
		}
		checkGroup.add(setBox[3]);
		checkGroup.add(setBox[4]);
		
		setNames();
	}
	
	public void setTitleNames()
	{
		if(settingData.inJapanese)
			message.setText(menuInJapanese[18]);
		else
			message.setText("Keyword SETTINGS (Please push the SETTINGS button after you customized)");
	}
	

	
	public void setNames()
	{
		String setWords[] = {"Windows","English","ChaSen Execution","SJIS (Code of ChaSen and InputText)","EUC (Code of ChaSen and InputText)", 
			"Exclude HIRAGANA words", "Exclude KATAKANA words", "Exclude One character words","Menu in Japanese (Reconstruct panels)"};
		
		if(settingData.inJapanese)
		{
			setFieldLabel.setText(menuInJapanese[3]);
			for(int i=0;i<9;i++)
				setBox[i].setText(menuInJapanese[4+i]);

			bt0.setText(menuInJapanese[14]);	
			bt10.setText(menuInJapanese[15]);
			bt20.setText(menuInJapanese[16]);
			bt30.setText(menuInJapanese[17]);
			bt40.setText(menuInJapanese[23]);
		}
		else
		{
			setFieldLabel.setText("ChaSen PATH (Except for Windows) Please PUSH Return key after modification");
			for(int i=0;i<9;i++)
				setBox[i].setText(setWords[i]);

			bt0.setText("Load Original Settings");	
			bt10.setText("Save Settings");
			bt20.setText("Reconstruct Panels");
			bt30.setText("Reset TextData");
			bt40.setText("Quit Settings");
		}
	}
	
	public void initializeSetBox()
	{
		setField.setText(settingData.chasenPath);
		
		for(int i=0;i<9;i++)
			setBox[i].setFont(new Font("Dialog", Font.BOLD, fontsize));
		
		setBox[0].setSelected(settingData.isWindows);
		setBox[0].setEnabled(false);
		setBox[1].setSelected(settingData.isEnglish);
		setBox[1].setEnabled(false);		
		setBox[2].setSelected(settingData.chasenexe);
		setBox[2].setEnabled(false);			
		setBox[3].setSelected(settingData.defaultCode.equals("SJIS"));
		setBox[3].setEnabled(false);		
		setBox[4].setSelected(settingData.defaultCode.equals("EUC-JP"));
		setBox[4].setEnabled(false);		
		setBox[5].setSelected(settingData.excludeHiragana);
		setBox[6].setSelected(settingData.excludeKatakana);
		setBox[7].setSelected(settingData.excludeOne);
		setBox[8].setSelected(settingData.inJapanese);
	}


	public void setData()
	{
		displayText[0] = settingData.guideComments[0]+"\n";
		for(int i=0;i<settingData.nouns;i++)
			displayText[0] += (settingData.kind_nouns[i]+" ");
		displayText[0] += "\n";
		
		displayText[1] = settingData.guideComments[1]+"\n";
		for(int i=0;i<settingData.verbs;i++)
			displayText[1] += (settingData.kind_verbs[i]+" ");
		displayText[1] += "\n";		
		
		displayText[2] = settingData.guideComments[2]+"\n";
		for(int i=0;i<settingData.touns;i++)
			displayText[2] += (settingData.kind_touns[i]+" ");
		displayText[2] += "\n";		
		
		displayText[3] = settingData.guideComments[3]+"\n";
		for(int i=0;i<settingData.noises;i++)
			displayText[3] += (settingData.kind_noises[i]+" ");		
		displayText[3] += "\n";		
		
		displayText[4] = settingData.guideComments[5]+"\n";
		displayText[4] += settingData.segment_tag;
		displayText[4] += "\n";
	}
	
	
	public void setDisplay()
	{
		autoSet = true;
		for(int i=0;i<5;i++)
		{
			textBox[i].setFont(new Font("Dialog", Font.BOLD, fontsize));		
			textBox[i].setText(displayText[i]);
			textBox[i].setCaretPosition(0);
		}
		autoSet = false;		
	}
	


	//Action listener
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == setField)
		{
			settingData.chasenPath = setField.getText();
			return;
		}
		

		
		// Reconstruct Panels
		if(e.getSource() == bt20)
		{
			control.moduleData.initializeModuleSubset();					
			control.panelsReConstruction();
			control.setButtonLabel();					// for English Menu
		}
		
		// Reset TextData
		if(e.getSource() == bt30)
		{
			updateTextSetting();
			
			control.textDataLoadingWithoutCopy();/////
			control.resetSelectpanelData(control.text);			
		}		
		
		if(e.getSource() == bt0)//Load Original Settings
		{

		
			settingData.readOriginalSettingFile();



			
			initializeSetBox();			
			setData();
			setDisplay();
			
				
			
			if(settingData.inJapanese)
				message.setText(menuInJapanese[1]);
			else
				message.setText("SETTINGS ARE LOADED (Please push the Settings button after you customized)");

		}
		
		if(e.getSource() == bt10)//Save Settings
		{
			settingData.saveSettingFile();
			if(settingData.inJapanese)
				message.setText(menuInJapanese[2]);
			else
				message.setText("SETTINGS ARE SAVED (Please push the Settings button after you customized)");
		}

		// Quit Settings
		if(e.getSource() == bt40)
		{
			control.bt0.setSelected(false);
			control.popForSetting.dispose();
		}
	}
	
	public void updateTextSetting()
	{
		String text0[] = textBox[0].getText().split("\n");
		if(text0.length > 1)
		{
			settingData.kind_nouns = text0[1].split(" ");
			settingData.nouns = settingData.kind_nouns.length;
		}

		String text1[] = textBox[1].getText().split("\n");
		if(text1.length > 1)
		{
			settingData.kind_verbs = text1[1].split(" ");
			settingData.verbs = settingData.kind_verbs.length;
		}		

		String text2[] = textBox[2].getText().split("\n");
		if(text2.length > 1)
		{
			settingData.kind_touns = text2[1].split(" ");
			settingData.touns = settingData.kind_touns.length;
		}
		
		String text3[] = textBox[3].getText().split("\n");
		if(text3.length > 1)
		{
			settingData.kind_noises = text3[1].split(" ");
			settingData.noises = settingData.kind_noises.length;
		}
		
		String text4[] = textBox[4].getText().split("\n");
		if(text4.length > 1)
			settingData.segment_tag = text4[1];		
	}
	
	
	
	public void itemStateChanged(ItemEvent e)
	{
		// Settings for TextData Creation
		for(int i=0;i<setBox.length;i++)
			if(e.getSource() == setBox[i])
			{
				switch(i)
				{
					case 1: settingData.isEnglish = setBox[1].isSelected();
						break;
					case 2: settingData.chasenexe = setBox[2].isSelected();
						break;
					case 3:
					case 4: if(setBox[3].isSelected())
								settingData.defaultCode = "SJIS";
							else 
								settingData.defaultCode = "EUC-JP";
						break;
					case 5: settingData.excludeHiragana = setBox[5].isSelected();
						break;
					case 6: settingData.excludeKatakana = setBox[6].isSelected();
						break;
					case 7: settingData.excludeOne = setBox[7].isSelected();
						break;
					case 8: settingData.inJapanese = setBox[8].isSelected();
                            control.panelsReConstruction();
                            control.setButtonLabel();					// for English Menu


						
						if(settingData.inJapanese)
							message.setText(menuInJapanese[0]);
						else
							message.setText("SETTINGS (Please push the Settings button after you customized)");						
						
						setTitleNames();

						setNames();
						
						break;
				}

				return;
			}
	}
}
